//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>

#include "\cpp\arrays_bcb.h"
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <Dialogs.hpp>

#define _MAX_DESCRIPTION_LEN_   255

//---------------------------------------------------------------------------

class TChannel
{
public:
    TChannel(){RealNumber=-1;};
    ~TChannel(){};
    int    Number;
    char    Description[_MAX_DESCRIPTION_LEN_];
    int    RealNumber;
};

class CDevice
{
public:
	CDevice()
	{
				Name = "";
				useNICard=false;

				moduleName = "";
                RSAddress = 0;
	};
	~CDevice()
    {
		for(int i=0;i<Channels.GetCount();i++)
		{
			delete Channels.Item(i);
		}
		Channels.Clear();
    };

	AnsiString			Name;
	bool			useNICard;
   	_PtrArray<TChannel>			Channels;

	AnsiString			moduleName;
    AnsiString			Description;

    UINT                RSAddress;
};
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
	TLabel *Label1;
	TLabel *Label2;
	TLabel *Label3;
	TListBox *ListBox1;
	THeaderControl *HeaderControl1;
	TButton *Button1;
	TButton *Button2;
	TListBox *ListBox2;
	THeaderControl *HeaderControl2;
	TEdit *Edit1;
	TBitBtn *BitBtn1;
	TBitBtn *BitBtn2;
	TOpenDialog *OpenDialog1;
    TLabel *Label4;
    TEdit *Edit2;
    TBitBtn *BitBtn3;
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall ListBox1DrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
	void __fastcall ListBox1Click(TObject *Sender);
	void __fastcall OnAddDevice(TObject *Sender);
	void __fastcall OnRemoveDevice(TObject *Sender);
	void __fastcall OnSave(TObject *Sender);
	void __fastcall ListBox2Click(TObject *Sender);
	void __fastcall OnSetChannel(TObject *Sender);
    void __fastcall OnSetRSAddress(TObject *Sender);
private:	// User declarations
public:		// User declarations
	__fastcall TForm1(TComponent* Owner);

   	_PtrArray<CDevice>			Devices;
    AnsiString					ProFile;

    CDevice* __fastcall RetrieveModuleInfo(char *FileName);
    void    __fastcall  RetrieveRealModuleChannels(CDevice *Device);
    void    __fastcall  UpdateLists();
    void    __fastcall  UpdateChannelsList();
    void    __fastcall  UpdateChannelEdit();

};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
 