#if !defined(AFX_USERDLG_H__40987E94_0DC3_4D43_9445_AA50FF745C4A__INCLUDED_)
#define AFX_USERDLG_H__40987E94_0DC3_4D43_9445_AA50FF745C4A__INCLUDED_

#include "..\classes\MSocket.h"
#include "SessionThread.h"
#include "\cpp\tcpdata.h"
#include "\cpp\arrays.h"
#include "\cpp\userinfo.h"
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// UserDlg.h : header file
//

class CMesQueue : public _PtrQueue<TCPDataStruct>
{
public:
	bool	Buisy;
};
/////////////////////////////////////////////////////////////////////////////
// CUserDlg dialog

class CUserDlg : public CDialog
{
// Construction
public:
	CUserDlg(CWnd* pParent = NULL);   // standard constructor

	CMSocket	Socket;
	UINT		Errors;

	CString			Name;
	CString			Pass;
	plUserStatus	Status;

	bool			Started;
	CString			deviceName;
	CString			DLLName;
	BYTE			*Parameters;
	HINSTANCE		DLL;
	UINT			SendTimer;
	UINT			TimerId;
	UINT			Timer;

	CFifo		InBuffer;
	CFifo		OutBuffer;

	void		Start();
	void		FreeDevice();
	void		Stop();

	CMesQueue	OutQueue;
	void		Queue_CanSend();
	void		Queue_Send();
	void		SendStruct_Queue(TCPDataStruct* Data);
	void		SendStruct(TCPDataStruct* Data);
	void		SendMessage_(UINT FuncId, BYTE *buffer, UINT Len);
	void		SendMessage_Queue(UINT FuncId, BYTE *buffer, UINT Len);
	void		SendError(UINT Code);
	void		SendOK();

	void		Close();
	void		Clear();

// Dialog Data
	//{{AFX_DATA(CUserDlg)
	enum { IDD = IDD_USERDIALOG1 };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CUserDlg)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CUserDlg)
	afx_msg void OnDestroy();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_USERDLG_H__40987E94_0DC3_4D43_9445_AA50FF745C4A__INCLUDED_)
