#if !defined(AFX_CIRCEXPCDLG_H__539C9D32_3F72_4D5E_8D31_37C9433C59F6__INCLUDED_)
#define AFX_CIRCEXPCDLG_H__539C9D32_3F72_4D5E_8D31_37C9433C59F6__INCLUDED_

#include "imports.h"
#include "\cpp\arrays.h"
#include "\cpp\tcpdata.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CircExpCDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CCircExpCDlg dialog

class CCircExpCDlg : public CDialog
{
// Construction
public:
	CCircExpCDlg(CWnd* pParent = NULL);   // standard constructor

	bool	Cancelled;
	int		ExpResult;

	UINT	SocketId;
	bool	connected;
	_PtrQueue<TCPDataStruct>	Queue;
	bool	QueueBusy;
	bool	complete;


	BOOL Start();
	void	Stop();
	void	QueueCanSend();
	void	Queue_Send();

	void	SendStruct(TCPDataStruct* Data);
	void	SendStruct_Queue(TCPDataStruct* Data);
	
	void	SendMessage_Queue(UINT FuncId, BYTE *buffer, UINT Len);
	void	SendMessage_(UINT FuncId, BYTE *buffer, UINT Len);
	
//	void	SendBuffer_Queue(BYTE *buffer, UINT Len);
	void	SendBuffer(BYTE *buffer, UINT Len);
// Dialog Data
	//{{AFX_DATA(CCircExpCDlg)
	enum { IDD = IDD_CIRCEXPCDLG_DIALOG };
	CProgressCtrl	m_Progress;
	CEdit	m_Status;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCircExpCDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CCircExpCDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnDestroy();
	virtual void OnCancel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CIRCEXPCDLG_H__539C9D32_3F72_4D5E_8D31_37C9433C59F6__INCLUDED_)
