#ifndef _userinfo_h_included_
#define _userinfo_h_included_

enum plUserStatus{usIdle,usConnecting,usConnected,usWaiting,usWorking,usDataSending,usDisconnect,usTimeout,usAdministrator};
extern char *plUserStatusNames[9];


class CUserInfo
{
private:
	char			*name;
	plUserStatus	plStatus;
	char			*sStatus;
	char			*address;
	char			*module;

	UINT	__fastcall	StoreChToBuffer(char *, BYTE *buffer);
	UINT	__fastcall	LoadChFromBuffer(char*&, BYTE *buffer);
public:
	CUserInfo();
	~CUserInfo();

	void __fastcall		SetName(char *);
	char* __fastcall	GetName();

	void __fastcall		SetStatus(plUserStatus);
	plUserStatus __fastcall	GetStatus();

	void __fastcall		SetStatusName(char *);
	char* __fastcall	GetStatusName();

	void __fastcall		SetAddress(char *);
	char* __fastcall	GetAddress();

	void __fastcall		SetModuleName(char *);
	char* __fastcall	GetModuleName();

	UINT	__fastcall	GetLen();

	UINT	__fastcall	ToBuffer(BYTE *buffer);
	UINT	__fastcall	FromBuffer(BYTE *buffer);
};

#endif