#if !defined(AFX_DIODEXP01CDLG_H__DEA1827A_886F_44CA_BD7F_16C8F1C20CBA__INCLUDED_)
#define AFX_DIODEXP01CDLG_H__DEA1827A_886F_44CA_BD7F_16C8F1C20CBA__INCLUDED_

#include "imports.h"
#include "\cpp\arrays.h"
#include "\cpp\tcpdata.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DiodExp01CDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CDiodExp01CDlg dialog

class CDiodExp01CDlg : public CDialog
{
// Construction
public:
	CDiodExp01CDlg(CWnd* pParent = NULL);   // standard constructor

	bool	Cancelled;
	int		ExpResult;

	UINT	SocketId;
	bool	connected;
	_PtrQueue<TCPDataStruct>	Queue;
	bool	QueueBusy;
	bool	complete;


	BOOL	Start();
	void	Stop();
	void	QueueCanSend();
	void	Queue_Send();

	void	SendStruct(TCPDataStruct* Data);
	void	SendStruct_Queue(TCPDataStruct* Data);
	
	void	SendMessage_Queue(UINT FuncId, BYTE *buffer, UINT Len);
	void	SendMessage_(UINT FuncId, BYTE *buffer, UINT Len);
	
//	void	SendBuffer_Queue(BYTE *buffer, UINT Len);
	void	SendBuffer(BYTE *buffer, UINT Len);
// Dialog Data
	//{{AFX_DATA(CDiodExp01CDlg)
	enum { IDD = IDD_DIODEXP01CDLG_DIALOG };
	CProgressCtrl	m_Progress;
	CEdit	m_Status;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDiodExp01CDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDiodExp01CDlg)
	virtual void OnCancel();
	virtual BOOL OnInitDialog();
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DIODEXP01CDLG_H__DEA1827A_886F_44CA_BD7F_16C8F1C20CBA__INCLUDED_)
