// OperExp02SDlg.cpp : implementation file
//

#include "stdafx.h"
#include "operexp02s.h"
#include "OperExp02SDlg.h"

#include "\cpp\labsignals.h"
#include "\cpp\labdata.h"
#include "\cpp\commands.h"
#include "\cpp\cwdaqconst.h"
#include "\cpp\cwsafearray_vc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


extern	char		moduleName[];
extern	HWND			MainWindow;

extern	COperExp02SDlg	*ExpWnd;
extern	char			ProFile[_MAX_PATH];

int		switches = 12;

/////////////////////////////////////////////////////////////////////////////
// COperExp02SDlg dialog


COperExp02SDlg::COperExp02SDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COperExp02SDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COperExp02SDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void COperExp02SDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COperExp02SDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COperExp02SDlg, CDialog)
	//{{AFX_MSG_MAP(COperExp02SDlg)
	ON_WM_DESTROY()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COperExp02SDlg message handlers

LRESULT COperExp02SDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	switch(message)
	{
	case WM_USER+_ID_DATA_GRAPH_:
		{
			if(!Prepared)
			{
				Prepared = true;
				StartExperiment();
				return 0;
			}


char str[128];
sprintf(str, "GraphIn");
::SendMessage(MainWindow, _ID_DATA_STATUS_STRING_, (WPARAM)str, (LPARAM)strlen(str));

			float *fltData;
			double *dblData;
			CCWSafeArray	*vData = new CCWSafeArray( *((VARIANT*)wParam) );
			BYTE type = (BYTE)((VARIANT*)wParam)->vt;
			long channels;
			long dim;

			if(vData->GetNDims() == 1)
			{
				channels = 1;
				dim = vData->GetDimSize(1);
			}
			else
			{
				channels = vData->GetDimSize(1);
				dim = vData->GetDimSize(2);
			}



			int elementSize;
			if( type &VT_R4)
			{
				elementSize = 4;
				fltData = (float*)vData->AccessData();
			}
			else
				if( type & VT_R8)
				{
					elementSize = 8;
					dblData = (double*)vData->AccessData();
				}
				else
				{
					elementSize = 4;
					fltData = (float*)vData->AccessData();
				}

			BYTE *data;
			for(BYTE i=0;(int)i<channels;i++)
			{
				int Len = elementSize*dim+1+sizeof(long)+sizeof(int);
				
				data = new BYTE[Len];
				data[0] = i;
				int offset = 1;
				memcpy(data+1, &elementSize, sizeof(int));
				offset += sizeof(int);
				memcpy(data+offset, &dim, sizeof(long));
				offset += sizeof(long);
				if(elementSize == 4)
				{
					for(int j=0;j<dim;j++)
					{
						if(channels == 1)
						{
//							fltData[j] = -fltData[j];
							memcpy( data+offset+j*elementSize, &(fltData[j]), sizeof(float));
						}
						else
						{
//							fltData[i+j*channels] = -fltData[i+j*channels];
							memcpy( data+offset+j*elementSize, &(fltData[i+j*channels]), sizeof(float));
						}
					}
				}
				else
				if(elementSize == 8)
				{
					for(int j=0;j<dim;j++)
					{
						if(channels == 1)
						{
//							dblData[j] = -dblData[j];
							memcpy( data+offset+j*elementSize, &(dblData[j]), sizeof(double));
						}
						else
						{
//							dblData[i+j*channels] = -dblData[i+j*channels];
							memcpy(data+offset+j*elementSize, &(dblData[i+j*channels]), sizeof(double));
						}
					}
				}
				::SendMessage(MainWindow, _ID_DATA_GRAPH_, (WPARAM)data, Len);
				delete[] data;

			}

			vData->UnaccessData();
			delete vData;
		
	        NIDAQFunction(_ID_SYSTEM_RESET_ALL_, 0);
				::PostMessage(MainWindow, _ID_COMMAND_EXPERIMENT_END_, 0, 0);
		
		
		
		}
		return 0;
	case _ID_COMMAND_EXPERIMENT_START_:
		{
char str[512];
sprintf(str, "ExperimentStart");
::SendMessage(MainWindow, _ID_DATA_STATUS_STRING_, (WPARAM)str, (LPARAM)strlen(str));
			if(wParam != NULL)
			{
				BYTE *buffer = (BYTE*)wParam;
				UINT len;
				memcpy(&len, buffer, sizeof(UINT));
/*{
			char str1[4];
			CString aBuffer="";
			for(UINT i=0;i<len+sizeof(UINT);i++)
			{
				int len = sprintf(str1, "%x ", buffer[i]);
				if(len == 2)
				{
					str1[3] = 0;
					str1[2] = str1[1];
					str1[1] = str1[0];
					str1[0] = '0';
				}
				aBuffer += CString(str1);
			}
			FILE *file = fopen("DataBuffer.txt","a+");
    		fprintf(file, "DataBuffer2 = '%s'\n", aBuffer.GetBuffer(0));
			fclose(file);
//::SendMessage(MainWindow, _ID_DATA_STATUS_STRING_, (WPARAM)str, (LPARAM)strlen(str));
}
*/
//sprintf(str, "ParamLen == %d", len);
//::SendMessage(MainWindow, _ID_DATA_STATUS_STRING_, (WPARAM)str, (LPARAM)strlen(str));
				if(len <=sizeof(UINT))
					return 0;
				int offset = sizeof(UINT);

				if(len < (UINT)(switches+offset))
					return 0;

//sprintf(str, "Switches", len);
//::SendMessage(MainWindow, _ID_DATA_STATUS_STRING_, (WPARAM)str, (LPARAM)strlen(str));
				//***********		Switches
				memcpy(Switches, buffer+offset, switches);
				offset+=switches;

//sprintf(str, "Measure params", len);
//::SendMessage(MainWindow, _ID_DATA_STATUS_STRING_, (WPARAM)str, (LPARAM)strlen(str));
				//***********		Measure params
				memcpy(&(Measure.mChNum), buffer+offset, sizeof(UINT));
				offset+=sizeof(UINT);
				Measure.mChs = new BYTE[Measure.mChNum];
				memcpy(Measure.mChs, buffer+offset, sizeof(BYTE)*Measure.mChNum);
				offset+=sizeof(BYTE)*Measure.mChNum;
				memcpy(&(Measure.PointsNum), buffer+offset, sizeof(UINT));
				offset+=sizeof(UINT);
				memcpy(&(Measure.PointsPerSec), buffer+offset, sizeof(UINT));
				offset+=sizeof(UINT);


//sprintf(str, "Sources", len);
//::SendMessage(MainWindow, _ID_DATA_STATUS_STRING_, (WPARAM)str, (LPARAM)strlen(str));
				//***********		Sources
			for(int i=0;i<2;i++)
			{
				SOURCE *Source = new SOURCE();
				Source->Type = buffer[offset];
				offset++;
				switch(Source->Type)
				{
				case _SIGNALS_TYPE_NONE_:
					break;
				case _SIGNALS_TYPE_PULSE_:
					{
//sprintf(str, "_SIGNALS_TYPE_PULSE_", len);
//::SendMessage(MainWindow, _ID_DATA_STATUS_STRING_, (WPARAM)str, (LPARAM)strlen(str));
						Signal_Pulse *Signal =  new Signal_Pulse();
						memcpy(&(Signal->T0), buffer+offset, sizeof(double));
						offset += sizeof(double);
						memcpy(&(Signal->Y0), buffer+offset, sizeof(double));
						offset += sizeof(double);
						Source->Recycle = buffer[offset];
						offset += 1;
						Source->data = (UINT)Signal;
					}
					break;
				case _SIGNALS_TYPE_SQUARE_:
					{
//sprintf(str, "_SIGNALS_TYPE_SQUARE_", len);
//::SendMessage(MainWindow, _ID_DATA_STATUS_STRING_, (WPARAM)str, (LPARAM)strlen(str));
						Signal_Square	*Signal = new Signal_Square();
						memcpy(&(Signal->T), buffer+offset, sizeof(double));
						offset += sizeof(double);
						memcpy(&(Signal->T0), buffer+offset, sizeof(double));
						offset += sizeof(double);
						memcpy(&(Signal->Y0), buffer+offset, sizeof(double));
						offset += sizeof(double);
						memcpy(&(Signal->T1), buffer+offset, sizeof(double));
						offset += sizeof(double);
						Source->Recycle = buffer[offset];
						offset += 1;
						Source->data = (UINT)Signal;
					}
					break;
				case _SIGNALS_TYPE_POLINOM_:
					{
//sprintf(str, "_SIGNALS_TYPE_POLINOM_", len);
//::SendMessage(MainWindow, _ID_DATA_STATUS_STRING_, (WPARAM)str, (LPARAM)strlen(str));
						Signal_Polinom	*Signal = new Signal_Polinom();
						memcpy(&(Signal->T), buffer+offset, sizeof(double));
						offset += sizeof(double);
						memcpy(&(Signal->N), buffer+offset, sizeof(int));
						offset += sizeof(int);

						Signal->Tn = new double[Signal->N];
						Signal->Yn = new double[Signal->N];
						for(int j=0;j<Signal->N;j++)
						{
							memcpy(&(Signal->Tn[j]), buffer+offset, sizeof(double));
							offset += sizeof(double);
							memcpy(&(Signal->Yn[j]), buffer+offset, sizeof(double));
							offset += sizeof(double);
						}

						Source->Recycle = buffer[offset];
						Source->data = (UINT)Signal;

						offset += 1;
					}
					break;
				case _SIGNALS_TYPE_SIN_:
					{
//sprintf(str, "_SIGNALS_TYPE_SIN_", len);
//::SendMessage(MainWindow, _ID_DATA_STATUS_STRING_, (WPARAM)str, (LPARAM)strlen(str));
						Signal_Sine	*Signal = new Signal_Sine();
						memcpy(&(Signal->F), buffer+offset, sizeof(double));
						offset += sizeof(double);
						memcpy(&(Signal->Y), buffer+offset, sizeof(double));
						offset += sizeof(double);
						memcpy(&(Signal->Fi), buffer+offset, sizeof(double));
						offset += sizeof(double);
						Source->Recycle = buffer[offset];
						Source->data = (UINT)Signal;
						offset += 1;
					}
					break;
				}
				Sources.Add(Source);
			}




sprintf(str, "SwitchesON");
::SendMessage(MainWindow, _ID_DATA_STATUS_STRING_, (WPARAM)str, (LPARAM)strlen(str));
				::SendMessage(MainWindow, _ID_RS485_COMMAND_+_ID_COMMAND_OPEN_DEVICE_, (WPARAM)devAddress, 0);
				SetSwitches(Switches);
			}
		}
		return 0;
	case _ID_SYSTEM_UNINITIALIZE_:
		{
			::SendMessage(MainWindow, _ID_RS485_COMMAND_+_ID_COMMAND_CLOSE_DEVICE_, (WPARAM)devAddress, 0);
Clear();
/*			if(NIDAQDLL != NULL)
			{
				if(NIDAQFunction != NULL)
				{
    				NIDAQFunction(_ID_SYSTEM_UNINITIALIZE_,0);
				}
            	FreeLibrary(NIDAQDLL);
                NIDAQDLL = NULL;
			}
*/		}
		return 0;
	case _ID_RS485_MESSAGE_:
		switch(wParam)
		{
		case _ID_RS485_MESSAGE_:
			{
//char str[512];
				CRS485Message *mes = (CRS485Message*)lParam;
				int	ID = (int)mes->GetID();
				switch(ID)
				{
				case cmOK:
//sprintf(str, "_ID_RS485_MESSAGE_ - cmOK");
//::SendMessage(MainWindow, _ID_DATA_STATUS_STRING_, (WPARAM)str, (LPARAM)strlen(str));
					StartExperiment();
					break;
				default:
					timeouts++;
					if(timeouts > 3)
					{
						::SendMessage(MainWindow, _ID_COMMAND_SEND_ERROR_, _ID_RS485_COMMAND_+ID, 0);
					}
					else
					{
						::SendMessage(MainWindow, _ID_RS485_COMMAND_+_ID_COMMAND_SEND_DATA_RETRIEVE_, (WPARAM)devAddress, 0);
					}
					break;
				}
			}
			break;
		case errTIMEOUT:
			{
//char str[512];
//sprintf(str, "_ID_RS485_MESSAGE_ - errTIMEOUT");
//::SendMessage(MainWindow, _ID_DATA_STATUS_STRING_, (WPARAM)str, (LPARAM)strlen(str));
			timeouts++;
			if(timeouts > 3)
			{
				::SendMessage(MainWindow, _ID_COMMAND_SEND_ERROR_, _ID_RS485_COMMAND_+errTIMEOUT, 0);
			}
			else
			{
				::SendMessage(MainWindow, _ID_RS485_COMMAND_+_ID_COMMAND_SEND_DATA_RETRIEVE_, (WPARAM)devAddress, 0);
			}
			}
			break;
		}
		return 0;
	}
	
	return CDialog::WindowProc(message, wParam, lParam);
}

BOOL COperExp02SDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	Prepared = false;
	NIDAQDLL=NULL;
	NIDAQFunction=NULL;
	Measure.mChs = NULL;

	devAddress = GetPrivateProfileInt(moduleName, "RSAddress", 229, ProFile);
	NChannels = GetPrivateProfileInt(moduleName, "Channels", 1, ProFile);
	Channels = new int[NChannels];
	char string[5];
	for(int i=0;i<NChannels;i++)
	{
		sprintf(string, "ch%d", i);
		Channels[i] = GetPrivateProfileInt(moduleName, string, i, ProFile);
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
BOOL COperExp02SDlg::DestroyWindow() 
{
	Clear();
	
	return CDialog::DestroyWindow();
}

void COperExp02SDlg::Clear()
{
			if(NIDAQDLL != NULL)
			{
				if(NIDAQFunction != NULL)
				{
    				NIDAQFunction(_ID_SYSTEM_UNINITIALIZE_,0);
				}
            	FreeLibrary(NIDAQDLL);
                NIDAQDLL = NULL;
			}

	if(Channels != NULL)
	{
		delete[] Channels;
		Channels = NULL;
	}

	if(Measure.mChs != NULL)
	{
		delete[] Measure.mChs;
		Measure.mChs = NULL;
	}	
	for(UINT i=0;i<Sources.GetCount();i++)
	{
		SOURCE *source = Sources[i];
		switch(source->Type)
		{
		case _SIGNALS_TYPE_PULSE_:
			delete (Signal_Pulse*)(source->data);
			break;
		case _SIGNALS_TYPE_SQUARE_:
			delete (Signal_Square*)(source->data);
			break;
		case _SIGNALS_TYPE_POLINOM_:
			delete (Signal_Polinom*)(source->data);
			break;
		case _SIGNALS_TYPE_SIN_:
			delete (Signal_Sine*)(source->data);
			break;
		}
		delete source;
	}
}

void COperExp02SDlg::OnDestroy() 
{
	CDialog::OnDestroy();

	Clear();
}

void COperExp02SDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnTimer(nIDEvent);
}

void COperExp02SDlg::StartExperiment()
{
char str[512];
//sprintf(str, "StartExperiment()");
//::SendMessage(MainWindow, _ID_DATA_STATUS_STRING_, (WPARAM)str, (LPARAM)strlen(str));




	_LabGraphDataArray Inputs;

			AIPar.AllocationMode = cwaiHostMemory;
			char ChannelString[255];
			char	str1[5];
			sprintf(ChannelString, "");
			for(UINT i=0;i<Measure.mChNum;i++)
			{
				if(i>0)
				{
					sprintf(str1, ",%d", (int)(Channels[Measure.mChs[i]]) );
					strcat(ChannelString, str1);
				}
				else
				{
					sprintf(ChannelString, "%d", (int)(Channels[Measure.mChs[i]]) );
				}
			}
            AIPar.ChannelString = ChannelString;
			AIPar.Coupling = cwaiDC;
			AIPar.InputMode = cwaiRSE;
			AIPar.LowerLimit = -10.;
			AIPar.ReturnDataType = cwaiVoltages;
			AIPar.UpperLimit = 10.;
			if(Prepared)
			{
				AIPar.NScans = Measure.PointsNum;
				AIPar.ScanClock = Measure.PointsPerSec;
			}
			else
			{
				AIPar.NScans = 100;
				AIPar.ScanClock = 1000;
			}

	AOPar.Infinite = TRUE;
	AOPar.AllocationMode = cwaoOnBoardFIFO;//cwaoHostMemory;//
	AOPar.AllowRegeneration = TRUE;
	AOPar.ClockSourceType = cwaoInternalCS;
	AOPar.ChannelType = cwaoVoltage;
	char chStr[5];
	sprintf(chStr, "0,1");
	AOPar.ChannelString = chStr;
	AOPar.UpperLimit = 10;
	AOPar.LowerLimit = -10;
	AOPar.NIterations = 1;
	AOPar.StartCondition = cwaoAIStartTrigger;//cwaoNoActiveCondition;//;

	UINT Points = 1000;
	AOPar.NUpdates = Points;//AIPar.NScans;
	double	T = (double)(AIPar.NScans)/(double)(AIPar.ScanClock);
	if(T<0.0005)
		T = 0.0005;
//	UINT	Points = AOPar.NUpdates;//1024;
	if(T < 0.002)
		Points/=2;
	if(T < 0.001)
		Points/=2;
	AOPar.ClockFrequency = ((float)Points)/(float)T;//AIparams->PointsPerSec;//Parameters->NUpdates;
	if(AOPar.ClockFrequency > 500000.)
	{
		AOPar.ClockFrequency = 500000.;
		AOPar.NUpdates = (LONG)((double)(AOPar.ClockFrequency)*T);
	}
	AOPar.RefType = cwaoInternal;

/*		Points = 1000;
//		T = (double)(AIPar.NScans)/(double)(AIPar.ScanClock);
		AOPar.ClockFrequency = AIPar.ScanClock;
		AOPar.NUpdates = 1000;//(LONG)((double)(AOPar.ClockFrequency)*T);
		T = (double)(AOPar.NUpdates) / AOPar.ClockFrequency; 
*/

/*{
	FILE *file = fopen("operexps.txt", "a+");
	fprintf(file, "AOPar.NUpdates == %d\n", AOPar.NUpdates);
	fprintf(file, "AOPar.ClockFrequency == %f\n", AOPar.ClockFrequency);
	fclose(file);
}
*/


sprintf(str, "Sources");
::SendMessage(MainWindow, _ID_DATA_STATUS_STRING_, (WPARAM)str, (LPARAM)strlen(str));

	for(i=0;i<Sources.GetCount();i++)
	{
		SOURCE *Source = Sources.Item(i);
		switch(Source->Type)
		{
		case _SIGNALS_TYPE_NONE_:
			{
				_LabGraphData *newData = Inputs.Add();
				_DoubleArray *newY = newData->AddDimR();
				for(UINT j=0;j<Points;j++)
				{
					newY->Add(0.0);
				}
			}
			break;
		case _SIGNALS_TYPE_PULSE_:
		case _SIGNALS_TYPE_SQUARE_:
		case _SIGNALS_TYPE_SIN_:
		case _SIGNALS_TYPE_POLINOM_:
			{

/*{
	FILE *file = fopen("operexps.txt", "a+");
	fprintf(file, "Y == %f\n", ((Signal_Sine*)(Source->data))->Y);
	fprintf(file, "F == %f\n", ((Signal_Sine*)(Source->data))->F);
	fclose(file);
}
*/
					_LabData *newData = new _LabData();
					double	*x = new double[Points];
					double	*y = new double[Points];
					GenerateSignal(Source->Type, (void*)(Source->data),x,y,
								Points,
								T,
								Source->Recycle);
/*{
	FILE *file = fopen("operexps.txt", "a+");
	for(int i=0;i<Points;i++)
	{
		fprintf(file, "X == %f\    Y == %f\n", x[i],y[i]);
	}
	fclose(file);
}
*/
					newData->AddDim(new _DoubleArray(y,Points));

					Inputs.Add(new _LabGraphData(newData));
					delete newData;
					delete x;
					delete y;
			}
		}
	}

	UINT sources = Inputs.GetCount();
	if(sources == 0)
		return;

	UINT Count = Inputs.Item(0)->Dim(0)->GetSize();
	UINT dCount=  Count*sources;
//	CCWSafeArray	vData(VT_R8, Count*sources);
	BYTE *buffer = new BYTE[1+sizeof(UINT)+dCount*sizeof(double)];
	double		*yData = (double*)(buffer+1+sizeof(UINT));//vData.AccessData();

	buffer[0] = (BYTE)sources;
	memcpy(buffer+1, &dCount, sizeof(UINT));

	UINT index = 0;
	if(Prepared)
	{
		for(i=0;i<Count;i++)
		{
			for(UINT j=0;j<sources;j++)
			{
				index = j+i*sources;
				yData[index] = Inputs.Item(j)->Dim(0)->Item(i);
//			index++;
			}
		}
	}
	else
	{
		for(i=0;i<Count;i++)
		{
			for(UINT j=0;j<sources;j++)
			{
				index = j+i*sources;
				yData[index] = 0.;
//			index++;
			}
		}
	}
//	vData.UnaccessData();


//sprintf(str, "Loading plnidaq.dll");
//::SendMessage(MainWindow, _ID_DATA_STATUS_STRING_, (WPARAM)str, (LPARAM)strlen(str));

    	NIDAQDLL = (HINSTANCE)LoadLibrary("plnidaq.dll");
        if(NIDAQDLL != NULL)
        {
        	NIDAQFunction = (FUNCTION1)GetProcAddress(NIDAQDLL, "_plnidaq");
            if(NIDAQFunction == NULL)
            {
            	FreeLibrary(NIDAQDLL);
                NIDAQDLL = NULL;
//sprintf(str, "NIDAQFunction == NULL");
//::SendMessage(MainWindow, _ID_DATA_STATUS_STRING_, (WPARAM)str, (LPARAM)strlen(str));
            }
            else
            {
sprintf(str, "ExpStart");
::SendMessage(MainWindow, _ID_DATA_STATUS_STRING_, (WPARAM)str, (LPARAM)strlen(str));
            	NIDAQFunction(_ID_SYSTEM_MAIN_WINDOW_, (UINT)m_hWnd);
            	NIDAQFunction(_ID_SYSTEM_INITIALIZE_,0);

				NIDAQFunction(_ID_SYSTEM_AI_SET_PARAMETERS_, (UINT)&AIPar);
	
				NIDAQFunction(_ID_SYSTEM_AO_SET_PARAMETERS_, (UINT)&AOPar);
		
				NIDAQFunction(_ID_SYSTEM_AO_SET_WAVEFORM_, (UINT)buffer);

				NIDAQFunction(_ID_SYSTEM_AO_START_, 0);
		        NIDAQFunction(_ID_SYSTEM_AI_START_, 0);

            

//	AOParameters *Parameters = new AOParameters;
//	char chStr[5];
//    double U,f,fi,T;

//    U = 2.;
//    	f = 50.;
//	    fi = 0.;
//		sprintf(chStr,"0");


//    T = 1./f;

//	UINT	Points = 1000;
/*
				Parameters->Infinite = true;
				Parameters->AllocationMode = cwaoOnBoardFIFO;//cwaoHostMemory;
				Parameters->AllowRegeneration = true;
				Parameters->NUpdates = Points;//AIparams->PointsNum;
				Parameters->ClockSourceType = cwaoInternalCS;
				Parameters->ChannelType = cwaoVoltage;
				Parameters->ChannelString = chStr;
				Parameters->UpperLimit = 10;
				Parameters->LowerLimit = -10;
				Parameters->NIterations = 1;
				Parameters->StartCondition = cwaoNoActiveCondition;//cwaoAIStartTrigger;//;
				Parameters->ClockFrequency = ((float)Points)/T;//AIparams->PointsPerSec;//Parameters->NUpdates;
				if(Parameters->ClockFrequency > 500000.)
				{
					Parameters->ClockFrequency = 500000.;
					Parameters->NUpdates = (LONG)((double)(Parameters->ClockFrequency)*T);
				}
				Parameters->RefType = cwaoInternal;

				NIDAQFunction(_ID_SYSTEM_AO_SET_PARAMETERS_, (UINT)Parameters);
*/
/*    	Points = Parameters->NUpdates;

        double om,t,dt;
        om = 2.*M_PI*f;
        dt = T/(double)Points;

        BYTE	*buffer = new BYTE[1+sizeof(UINT)+sizeof(double)*Points];
        buffer[0] = 1;
        memcpy(buffer+1, &Points, sizeof(UINT));
        double	*data = (double*)(buffer+1+sizeof(UINT));

        t=0.;
		for(int i=0;i<1000;i++)
        {
			UINT index = i;
               t = i*dt;
    		data[i] = U*sin(om*t+fi);
        }
*/
/*		NIDAQFunction(_ID_SYSTEM_AO_SET_WAVEFORM_, (UINT)buffer);


        NIDAQFunction(_ID_SYSTEM_AO_START_, 0);
        NIDAQFunction(_ID_SYSTEM_AI_START_, 0);

		delete Parameters;
*/				
//*********************			
				delete[] buffer;
			}
        }
		else
		{
sprintf(str, "NIDAQDLL = NULL");
::SendMessage(MainWindow, _ID_DATA_STATUS_STRING_, (WPARAM)str, (LPARAM)strlen(str));
		}


//		Clear();
}


//*************************************************************
void COperExp02SDlg::SetSwitches(BYTE *values)
{
	CRS485Message newData;	
	int dataLen = 6;
			newData.SetID(cmSET);	//*****************
			BYTE *data = new BYTE[6];
			BYTE	low,high;

			if(values[0] == 0xFF)	//	R1
				low = 0;
			else
				low = values[0] + 8;
			if(values[1] == 0xFF)	//	R2
				high = 0;
			else
				high = values[1] + 8;
			high = (high&0x0F)<<4;
			data[0] = low + high;

			if(values[9] == 1)	//	C1 & sw1
				low = 8;
			else
				if(values[6] == 0xFF)
					low = 0;
				else
					low	= values[6] + 8;
			if(values[11] == 1 || values[11] == 2)
				high = values[11]+7;
			else 
				high = 0; //	sw2
	
			high = (high&0x0F)<<4;
			data[1] = low + high;

			if(values[2] == 0xFF)	//	R3
				low = 0;
			else
				low = values[2] + 8;
			if(values[3] == 0xFF)	//	R4
				high = 0;
			else
				high = values[3]+8;
			high = (high&0x0F)<<4;
			data[2] = low + high;

			if(values[7] == 0xFF)	//	C2
				low = 0;
			else
				low = values[7] + 8;
			data[3] = low;

			if(values[4] == 0xFF)	//	R5
				low = 0;
			else
				low = values[4] + 8;
			if(values[5] == 0xFF)	//	R6
				high = 0;
			else
				high = values[5]+8;
			high = (high&0x0F)<<4;
			data[4] = low + high;

			if(values[10] == 1)		// vd & C3
				low = 8;
			else
				if(values[8] == 0xFF)
					low = 0;
				else
					low = values[8] + 8;
			data[5] = low;

	newData.SetAddress(devAddress);
	newData.SetData(dataLen, data);
	newData.CalcChSum();

//char str[512];
//sprintf(str, "Sending switches data...");
//::SendMessage(MainWindow, _ID_DATA_STATUS_STRING_, (WPARAM)str, (LPARAM)strlen(str));
	::SendMessage(MainWindow, _ID_RS485_COMMAND_+_ID_COMMAND_SEND_DATA_, (WPARAM)&newData, 0);
	timeouts = 0;
	delete[] data;
}

