#if !defined(AFX_OPEREXP02SDLG_H__838A439E_61D9_4E95_9A12_13CF0302459B__INCLUDED_)
#define AFX_OPEREXP02SDLG_H__838A439E_61D9_4E95_9A12_13CF0302459B__INCLUDED_

#include "..\..\pilabrs485\comm485.h"
#include "\cpp\commands.h"
#include "\cpp\arrays.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// OperExp02SDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// COperExp02SDlg dialog

class COperExp02SDlg : public CDialog
{
// Construction
public:
	COperExp02SDlg(CWnd* pParent = NULL);   // standard constructor

	BYTE			Switches[12];
	AOParameters	AOPar;
	AIParameters	AIPar;
	int			NChannels;
	int			*Channels;
	_PtrArray<SOURCE>	Sources;
	MEASUREPARAMS		Measure;

	HINSTANCE	NIDAQDLL;
	FUNCTION1	NIDAQFunction;

	BYTE			devAddress;
	int				timeouts;

	bool			Prepared;

	void			Clear();
	void			StartExperiment();
	void			SetSwitches(BYTE *values);

// Dialog Data
	//{{AFX_DATA(COperExp02SDlg)
	enum { IDD = IDD_OPEREXP02SDLG_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COperExp02SDlg)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(COperExp02SDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnDestroy();
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_OPEREXP02SDLG_H__838A439E_61D9_4E95_9A12_13CF0302459B__INCLUDED_)
