#if !defined(AFX_OPEREXP02SWND_H__4A8EE50C_A2D5_48B1_8BD6_7812AA315C3F__INCLUDED_)
#define AFX_OPEREXP02SWND_H__4A8EE50C_A2D5_48B1_8BD6_7812AA315C3F__INCLUDED_

#include "..\..\pilabrs485\comm485.h"
#include "\cpp\commands.h"
#include "\cpp\arrays.h"


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// OperExp02SWnd.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// COperExp02SWnd window

class COperExp02SWnd : public CWnd
{
// Construction
public:
	COperExp02SWnd();

// Attributes
public:
	BYTE			Switches[12];
	AOParameters	AOPar;
	AIParameters	AIPar;
	int			NChannels;
	int			*Channels;
	_PtrArray<SOURCE>	Sources;
	MEASUREPARAMS		Measure;

	HINSTANCE	NIDAQDLL;
	FUNCTION1	NIDAQFunction;

	BYTE			devAddress;
	int				timeouts;

	void			StartExperiment();
	void			SetSwitches(BYTE *values);
// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COperExp02SWnd)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~COperExp02SWnd();

	// Generated message map functions
protected:
	//{{AFX_MSG(COperExp02SWnd)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_OPEREXP02SWND_H__4A8EE50C_A2D5_48B1_8BD6_7812AA315C3F__INCLUDED_)
