#if !defined(AFX_RS485FORM_H__DF9AE6DC_A535_4737_AC4C_3BA7615A66D9__INCLUDED_)
#define AFX_RS485FORM_H__DF9AE6DC_A535_4737_AC4C_3BA7615A66D9__INCLUDED_

#include "\cpp\arrays.h"
#include "\cpp\fifo.h"
#include "deviceUnit1.h"
#include "\cpp\serial\serialmfc.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// RS485Form.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CRS485Form dialog

class CRS485Form : public CDialog
{
// Construction
public:
	CRS485Form(CWnd* pParent = NULL);   // standard constructor


	CString		PortName;
	int			Port;
	int			ComPort;
	CSerialMFC	*Comm1;
	CFifo		RSBuffer;
	BYTE		MyAddress;

	bool		RTS;
	bool		canRead;
	bool		readTimeoutStarted;
	bool		readTimeout;

	CRS485DeviceCollection	Devices;

	bool	OpenPort();

	bool	OpenDevice(BYTE address);

	bool	__fastcall  Send(BYTE Address);
	bool	__fastcall  Send(CRS485Device *Device);
	bool	__fastcall  SendNext(BYTE Address);
	bool	__fastcall  Send(CRS485Message *message);
	UINT	__fastcall  SendWait(CRS485Message *message);
	bool	__fastcall  Send(CRS485Device *Device, CRS485Message *message);
	void    __fastcall	Send(BYTE address, BYTE command, BYTE *buffer, UINT Len);
	void    __fastcall  ProcessDevices();
	void    __fastcall ProcessRSMessages();
	void    __fastcall DebugBufferToFile(BYTE *buffer, UINT Count);
	void    __fastcall DebugStrToFile(LPSTR mes);
// Dialog Data
	//{{AFX_DATA(CRS485Form)
	enum { IDD = IDD_RS485FORM_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRS485Form)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CRS485Form)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	//}}AFX_MSG
	afx_msg LRESULT OnSerialMsg (WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RS485FORM_H__DF9AE6DC_A535_4737_AC4C_3BA7615A66D9__INCLUDED_)
