//---------------------------------------------------------------------------
#include "stdafx.h"
#include "deviceUnit1.h"

//---------------------------------------------------------------------------

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


//---------------------------------------------------------------------------
CRS485Device::CRS485Device()
{
//    OutQueue = new TQueue();
//    InQueue = new TQueue();

    errStatus = cmOK;
    TimerTick = 0;
    Timer = false;
    Ready = true;
    Address = 0;
}

CRS485Device::~CRS485Device()
{
    while(OutQueue.GetCount()>0)
    {
        CRS485Message *mes = OutQueue.Pop();
//        delete mes;
    }
    while(InQueue.GetCount()>0)
    {
        CRS485Message *mes = InQueue.Pop();
//        delete mes;
    }
}

//---------------------------------------------------------------------------
CRS485DeviceCollection::CRS485DeviceCollection()
    :_PtrArray<CRS485Device>()
{
}

/*CRS485Device*   __fastcall  CRS485DeviceCollection::Item(int index)
{
    return (CRS485Device*)Items[index];
}
*/
/*void __fastcall CRS485DeviceCollection::Clear()
{
    while(GetCount() > 0)
    {
        Delete(0);
    }
}

void __fastcall CRS485DeviceCollection::Delete(int Index)
{
//    delete Item(Index);
    TList::Delete(Index);
}
*/
CRS485Device* __fastcall CRS485DeviceCollection::First()
{
    return Item(0);
}

CRS485Device* __fastcall CRS485DeviceCollection::Last()
{
    return Item(GetCount()-1);
}

int __fastcall CRS485DeviceCollection::FindIndex(BYTE Address)
{
    for(int i=0;i<GetCount();i++)
    {
        if(Item(i)->Address == Address)
            return i;
    }
    return -1;
}
CRS485Device*    __fastcall CRS485DeviceCollection::Find(BYTE Address)
{
    for(int i=0;i<GetCount();i++)
    {
        CRS485Device *item = Item(i);
        if(item->Address == Address)
            return item;
    }
    return NULL;
}

//---------------------------------------------------------------------------

