//---------------------------------------------------------------------------

#ifndef deviceUnit1H_included_
#define deviceUnit1H_included_

//#include "y:\include\fifo.h"
#include "\cpp\arrays.h"
#include "comm485.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


//---------------------------------------------------------------------------
class CRS485Device
{
public:
    CRS485Device();
    ~CRS485Device();

    BYTE    Address;
    _PtrQueue<CRS485Message>  OutQueue;
    _PtrQueue<CRS485Message>  InQueue;

    bool	Timer;
    UINT    TimerTick;

    bool    Ready;
    UINT    errStatus;
};
//---------------------------------------------------------------------------
class CRS485DeviceCollection : public _PtrArray<CRS485Device>
{
public:
    CRS485DeviceCollection();

//    CRS485Device*   __fastcall  Item(int index);
//    void            __fastcall  Clear();
//protected:
//    void __fastcall Delete(int Index);
    CRS485Device* __fastcall First();
    CRS485Device* __fastcall Last();
public:    
    int             __fastcall FindIndex(BYTE Address);
    CRS485Device*    __fastcall Find(BYTE Address);
};

//---------------------------------------------------------------------------
#endif
