// psmonitorDlg.cpp : implementation file
//

#include "stdafx.h"
#include "psmonitor.h"
#include "psmonitorDlg.h"
#include "OptionsDlg1.h"
#include "\cpp\commands.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


extern CPsmonitorApp theApp;
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPsmonitorDlg dialog

CPsmonitorDlg::CPsmonitorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPsmonitorDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPsmonitorDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPsmonitorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPsmonitorDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPsmonitorDlg, CDialog)
	//{{AFX_MSG_MAP(CPsmonitorDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	ON_COMMAND(ID_CLOSEBUTTON, OnClosebutton)
	ON_COMMAND(ID_OPTIONSBUTTON, OnOptionsbutton)
	ON_COMMAND(ID_DEVBUTTON, OnDevbutton)
	ON_COMMAND(ID_STARTBUTTON, OnStartbutton)
	ON_WM_SHOWWINDOW()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPsmonitorDlg message handlers

BOOL CPsmonitorDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

        	char    drive[_MAX_DRIVE],dir[_MAX_DIR],fname[_MAX_FNAME],ext[_MAX_EXT];
        	char    path[_MAX_PATH];

        	GetModuleFileName(0,path,_MAX_PATH);
        	_splitpath( path, drive, dir, fname, ext );
     	sprintf(ProFile,"%s%s%s",drive,dir,"pilabserver.ini");
		sprintf(Dir, "%s%s",drive,dir);

		
	ServerDlg = NULL;
	
	Toolbar.CreateEx(this);
	Toolbar.LoadToolBar(IDR_TOOLBAR1);
	Toolbar.ShowWindow(SW_SHOW);
	Toolbar.GetToolBarCtrl().SetStyle(WS_CHILD | WS_VISIBLE | TBSTYLE_FLAT | TBSTYLE_TOOLTIPS | TBSTYLE_WRAPABLE | CBRS_TOP| CBRS_TOOLTIPS);
//	Toolbar.SetButtonStyle(0,TBBS_CHECKBOX);
	RECT wndRect;
	Toolbar.GetWindowRect(&wndRect);
	int ToolbarHeight = wndRect.bottom - wndRect.top;	

	int sDlgHeight = 0;
	if(StatusDlg.Create(IDD_STATUSDLG_DIALOG,this))
	{
		CRect wndRect;
		StatusDlg.ShowWindow(SW_SHOW);
		StatusDlg.GetWindowRect(&wndRect);
		sDlgHeight = wndRect.bottom - wndRect.top;
	}

	RECT rcParent; 
	// Header
        HDLAYOUT hdl; 
        WINDOWPOS wp; 
 
        if ((Header.m_hWnd = CreateWindowEx(0, WC_HEADER, (LPCTSTR) NULL, 
                WS_CHILD | WS_BORDER | HDS_BUTTONS | HDS_HORZ | CCS_TOP | HDS_HOTTRACK | CCS_NODIVIDER|CCS_NORESIZE, 
                0, 0, 0, 0, m_hWnd, (HMENU) ID_HEADER, AfxGetApp()->m_hInstance, 
                (LPVOID) NULL)) == NULL) 
            return FALSE; 
 
        GetClientRect(&rcParent);

        hdl.prc = &rcParent; 
        hdl.pwpos = &wp; 
        if (!::SendMessage(Header.m_hWnd, HDM_LAYOUT, 0, (LPARAM) &hdl)) 
            return FALSE; 
 
		wp.y+=ToolbarHeight-3;
        // Set the size, position, and visibility of the header control. 
        ::SetWindowPos(Header.m_hWnd, wp.hwndInsertAfter, wp.x, wp.y+sDlgHeight, 
            wp.cx, wp.cy, wp.flags | SWP_SHOWWINDOW); 
		int	HeaderHeight = wp.cy;
		{
			InsertHeaderItem(0, 200, " ");
			InsertHeaderItem(1, 100, "");
			InsertHeaderItem(2, 100, "");
			InsertHeaderItem(3, 200, "");
		}
	Header.GetWindowRect(&wndRect);

	
	// ListBox
    GetClientRect(&rcParent); 
	rcParent.top-=HeaderHeight-ToolbarHeight;
	ListBox.Create(LBS_OWNERDRAWFIXED|LBS_NOTIFY|LBS_HASSTRINGS,rcParent,this,IDC_LISTBOX);
        GetClientRect(&rcParent); 
 
        ListBox.SetWindowPos(&wndTop, rcParent.left, rcParent.top, 
            rcParent.right-rcParent.left, rcParent.bottom-rcParent.top, SWP_SHOWWINDOW); 

/*				ListBox.AddString("User1#connected");
				ListBox.SetItemData(0,0);
				ListBox.AddString("User2#connected");
				ListBox.SetItemData(1,1);
*/
	Header.ListBox = &ListBox;
	ListBox.Header = &Header;
//  RepositionBars(AFX_IDW_CONTROLBAR_FIRST, AFX_IDW_CONTROLBAR_LAST, 0);
	UpdateData(TRUE);
	Toolbar.SetWindowPos(&wndTop,0,0,0,0,SWP_NOSIZE);

	Toolbar.GetToolBarCtrl().EnableButton(ID_STARTBUTTON, TRUE);
	Toolbar.GetToolBarCtrl().EnableButton(ID_CLOSEBUTTON, FALSE);


/*	NOTIFYICONDATA IconData;
	IconData.cbSize = sizeof(IconData);
	IconData.hWnd = m_hWnd;
	IconData.uID = IDI_TRAY;
	IconData.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
	IconData.hIcon = theApp.LoadIcon(IDI_TRAY);
	IconData.uCallbackMessage = WM_USER+3;
	sprintf(IconData.szTip,"Lab Server Engine");
	Shell_NotifyIcon(NIM_ADD, &IconData);
*/
	// CG: The following block was added by the ToolTips component.
	{
		// Create the ToolTip control.
//		m_tooltip.Create(this);
//		m_tooltip.Activate(TRUE);
	m_tooltip.Create(this, TTS_ALWAYSTIP);

	CRect rect;

	Toolbar.GetToolBarCtrl().GetItemRect(ID_STARTBUTTON, rect);
	m_tooltip.AddTool(&Toolbar, ID_STARTBUTTON, rect, ID_STARTBUTTON);


	Toolbar.GetToolBarCtrl().GetItemRect(ID_CLOSEBUTTON, rect);
	m_tooltip.AddTool(&Toolbar, ID_CLOSEBUTTON, rect, ID_CLOSEBUTTON);

	Toolbar.GetToolBarCtrl().GetItemRect(ID_OPTIONSBUTTON, rect);
	m_tooltip.AddTool(&Toolbar, ID_OPTIONSBUTTON, rect, ID_OPTIONSBUTTON);

	Toolbar.GetToolBarCtrl().GetItemRect(ID_DEVBUTTON, rect);
	m_tooltip.AddTool(&Toolbar, ID_DEVBUTTON, rect, ID_DEVBUTTON);

	Toolbar.GetToolBarCtrl().SetToolTips(&m_tooltip);

		// TODO: Use one of the following forms to add controls:
		// m_tooltip.AddTool(GetDlgItem(IDC_<name>), <string-table-id>);
		// m_tooltip.AddTool(GetDlgItem(IDC_<name>), "<text>");
	}

	SetSizes();

						StatusDlg.m_Status.SetWindowText("Not loaded");
						StatusDlg.m_Connections.SetWindowText("");
						StatusDlg.m_Devices.SetWindowText("");

	NOTIFYICONDATA IconData;
	IconData.cbSize = sizeof(IconData);
	IconData.hWnd = m_hWnd;
	IconData.uID = IDI_TRAY;
	IconData.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
	IconData.hIcon = theApp.LoadIcon(IDR_MAINFRAME);
	IconData.uCallbackMessage = WM_USER+3;
	sprintf(IconData.szTip,"PILab Server Monitor");
	Shell_NotifyIcon(NIM_ADD, &IconData);

	Show = true;

	SetTimer(1,2000,NULL);

	return TRUE;  // return TRUE  unless you set the focus to a control
}
void CPsmonitorDlg::InsertHeaderItem(int index, int Width, char *ItemText)
{
	SHeaderTab *newTab = new SHeaderTab;
	newTab->Size = Width;
	newTab->Name = CString(ItemText);
	Header.Tabs.Add(newTab);

	HDITEM newItem;
		newItem.mask = HDI_WIDTH|HDI_TEXT;
		newItem.cxy = Width;
		newItem.pszText = ItemText;
		newItem.cchTextMax = strlen(ItemText);
		newItem.fmt = HDF_LEFT | HDF_STRING;
		Header.InsertItem(index, &newItem);
}

void CPsmonitorDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		if(nID == SC_MINIMIZE)
		{
			Show = false;
			ShowWindow(SW_HIDE);
		}
		else
		{
			CDialog::OnSysCommand(nID, lParam);
		}
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPsmonitorDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPsmonitorDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPsmonitorDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CPsmonitorDlg::OnOK() 
{
	// TODO: Add extra validation here
	
	CDialog::OnOK();
}

void CPsmonitorDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);

	SetSizes();
}

void CPsmonitorDlg::SetSizes()
{
	if(Toolbar.m_hWnd == NULL)
		return;
	try{
		
//	RECT rcLogBox;
//	m_LogBox.GetWindowRect(&rcLogBox);
	int LogHeight = 0;//rcLogBox.bottom - rcLogBox.top;


/*	RECT DlgRect;
	GetWindowRect(&DlgRect);
	if( (DlgRect.bottom - DlgRect.top) < LogHeight*3)
	{
		SetWindowPos(NULL, DlgRect.left,DlgRect.top,DlgRect.right-DlgRect.left, LogHeight*3, SWP_NOZORDER);
	}
*/
	RECT wndRect,ClRect;
	GetClientRect(&ClRect);
	int Width = ClRect.right-ClRect.left;
	int Height = ClRect.bottom - ClRect.top;

	Toolbar.GetWindowRect(&wndRect);
	int ToolbarHeight = wndRect.bottom - wndRect.top;

	StatusDlg.GetWindowRect(&wndRect);
	int sDlgHeight = wndRect.bottom - wndRect.top;
	StatusDlg.SetWindowPos(NULL,ClRect.left,ToolbarHeight,Width,sDlgHeight, SWP_NOZORDER);
	
	Header.GetWindowRect(&wndRect);
	int HeaderHeight = wndRect.bottom - wndRect.top;
	Header.SetWindowPos(NULL,wndRect.left,ToolbarHeight+sDlgHeight,Width,HeaderHeight, SWP_NOZORDER|SWP_NOMOVE);

	int LBHeight = Height-HeaderHeight-ToolbarHeight+3-LogHeight;
	ListBox.SetWindowPos(NULL,ClRect.left,ToolbarHeight+HeaderHeight+sDlgHeight,Width,LBHeight, SWP_NOZORDER);
//	m_LogBox.SetWindowPos(NULL,ClRect.left,ToolbarHeight+HeaderHeight+LBHeight+3,Width,LogHeight, SWP_NOZORDER);
	}
	catch(...)
	{
	}
}

BOOL CPsmonitorDlg::PreTranslateMessage(MSG* pMsg) 
{
try{
	// CG: The following block was added by the ToolTips component.
	{
		// Let the ToolTip process this message.
		m_tooltip.RelayEvent(pMsg);
	}

	return CDialog::PreTranslateMessage(pMsg);	// CG: This was added by the ToolTips component.
}
catch(...)
{
	return FALSE;
}
}

BOOL CPsmonitorDlg::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult) 
{
	try{
	if(wParam == ID_HEADER)
	{
		HD_NOTIFY *phdn = (HD_NOTIFY FAR *)lParam;	
		if(phdn->hdr.code == HDN_ENDTRACK)
		{
			 
			if(phdn->pitem != NULL)
			{
				Header.Tabs[phdn->iItem]->Size = phdn->pitem->cxy;
				ListBox.Invalidate(TRUE);
				return TRUE;
			}
		}
	}
	}
	catch(...)
	{
	}
	
	return CDialog::OnNotify(wParam, lParam, pResult);
}

void CPsmonitorDlg::OnOptionsbutton() 
{
	COptionsDlg1 OptDlg;
	
	UINT	uiNumber = GetPrivateProfileInt("SYSTEM","Port",7777,ProFile);
	char str1[12];
	sprintf(str1, "%d", uiNumber);
	OptDlg.m_Port = CString(str1);

	uiNumber = GetPrivateProfileInt("SYSTEM","ComPort",1,ProFile);
	sprintf(str1, "%d", uiNumber);
	OptDlg.m_ComPort = CString(str1);

	uiNumber = GetPrivateProfileInt("SYSTEM","Address",1,ProFile);
	sprintf(str1, "%d", uiNumber);
	OptDlg.m_RSAddress = CString(str1);

	if(OptDlg.DoModal() == IDOK)
	{
		WritePrivateProfileString("SYSTEM","Port",OptDlg.m_Port.GetBuffer(0),ProFile);
		WritePrivateProfileString("SYSTEM","ComPort",OptDlg.m_ComPort.GetBuffer(0),ProFile);
		WritePrivateProfileString("SYSTEM","Address",OptDlg.m_RSAddress.GetBuffer(0),ProFile);
	}
}

LRESULT CPsmonitorDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	switch(message)
	{
	case WM_USER+3://tray icon
		{
			switch(lParam)
			{
			case WM_LBUTTONDBLCLK:
				{
					ShowWindow(SW_SHOW);
				}
				break;
			}
			return TRUE;
		}
	case WM_TIMER:
		{
			if(wParam == 1 && Show)
			{
				HWND sWnd = ::FindWindow(NULL, "PilabServer");
//				HWND sWnd = ::FindWindow("#32770", NULL);
				HANDLE		hMapFile=NULL;
				hMapFile = OpenFileMapping(FILE_MAP_ALL_ACCESS,true,"PILabSystemFile");
				 if(sWnd != ServerDlg)
				 {
					if(ServerDlg == NULL)
					{
						char str[12];
						
						UINT listen;
						::SendMessage(ServerDlg, WM_USER+_ID_COMMAND_GET_LISTEN_, NULL, 0);
						if(hMapFile != NULL)
						{
							LPVOID buffer = MapViewOfFile(hMapFile,FILE_MAP_READ,0,0,0xFFFF);
							memcpy(&listen, buffer, sizeof(UINT));
							UnmapViewOfFile(buffer);
						}
						if(listen == 1)
						{
							StatusDlg.m_Status.SetWindowText("Listening...");
						}
						else
						{
							StatusDlg.m_Status.SetWindowText("Loaded.");
						}

						if(hMapFile != NULL)
						{
							::SendMessage(ServerDlg, WM_USER+_ID_COMMAND_GET_DEVICES_, NULL, 0);
							LPVOID buffer = MapViewOfFile(hMapFile,FILE_MAP_READ,0,0,0xFFFF);
							UINT devices;
							memcpy(&devices, buffer, sizeof(UINT));
							UnmapViewOfFile(buffer);
							sprintf(str, "%d", devices);
							StatusDlg.m_Devices.SetWindowText(str);
						}
					}
					else
					{
						StatusDlg.m_Status.SetWindowText("Not loaded");
						StatusDlg.m_Connections.SetWindowText("");
						StatusDlg.m_Devices.SetWindowText("");
					}

					
					ServerDlg = sWnd;
				 }

				 if(ServerDlg != NULL)
				 {
						if(hMapFile != NULL)
						{
							LPVOID buffer;
							::SendMessage(ServerDlg, WM_USER+_ID_COMMAND_GET_CONNECTIONS_, NULL, 0);
							UINT connections;
							buffer = MapViewOfFile(hMapFile,FILE_MAP_READ,0,0,0xFFFF);
							memcpy(&connections, buffer, sizeof(UINT));
							UnmapViewOfFile(buffer);
							char str[12];
							sprintf(str, "%d", connections);
							StatusDlg.m_Connections.SetWindowText(str);


							_PtrArray<CUserInfo> *Info = new _PtrArray<CUserInfo>();
							::SendMessage(ServerDlg, WM_USER+_ID_COMMAND_GET_USERS_, NULL, 0);
							buffer = MapViewOfFile(hMapFile,FILE_MAP_READ,0,0,0xFFFF);
							memcpy(&connections, buffer, sizeof(UINT));
							UINT offset = sizeof(UINT);
							for(UINT i=0;i<connections;i++)
							{
								CUserInfo *user = new CUserInfo();
								offset = user->FromBuffer((BYTE*)buffer+offset);
								Info->Add(user);
							}
							UnmapViewOfFile(buffer);

							ListBox.ResetContent();
							char string[128];
							for(i=0;i<connections;i++)
							{
								CUserInfo *user = Info->Item(i);
								if(user->GetName() == NULL)
									user->SetName(" ");
								if(user->GetModuleName() == NULL)
									user->SetModuleName(" ");
								sprintf(string,"%s#%s#%s#%s", user->GetName(), plUserStatusNames[user->GetStatus()], user->GetModuleName(), user->GetAddress());
								ListBox.AddString(string);
								ListBox.SetItemData(i,i);
								delete user;
							}
							Info->Clear();
							delete Info;
				
						UINT listen;
						::SendMessage(ServerDlg, WM_USER+_ID_COMMAND_GET_LISTEN_, NULL, 0);
						if(hMapFile != NULL)
						{
							LPVOID buffer = MapViewOfFile(hMapFile,FILE_MAP_READ,0,0,0xFFFF);
							memcpy(&listen, buffer, sizeof(UINT));
							UnmapViewOfFile(buffer);
						}
						if(listen == 1)
						{
							StatusDlg.m_Status.SetWindowText("Listening...");
						}
						else
						{
							StatusDlg.m_Status.SetWindowText("Loaded.");
						}

						if(hMapFile != NULL)
						{
							::SendMessage(ServerDlg, WM_USER+_ID_COMMAND_GET_DEVICES_, NULL, 0);
							LPVOID buffer = MapViewOfFile(hMapFile,FILE_MAP_READ,0,0,0xFFFF);
							UINT devices;
							memcpy(&devices, buffer, sizeof(UINT));
							UnmapViewOfFile(buffer);
							sprintf(str, "%d", devices);
							StatusDlg.m_Devices.SetWindowText(str);
						}
						
						}
				 }
				 else
				 {
				 }

			}

			if(ServerDlg != NULL)
			{
					 Toolbar.GetToolBarCtrl().EnableButton(ID_STARTBUTTON, FALSE);
					 Toolbar.GetToolBarCtrl().EnableButton(ID_CLOSEBUTTON, TRUE);
			}
			 else
			 {
					 Toolbar.GetToolBarCtrl().EnableButton(ID_STARTBUTTON, TRUE);
					 Toolbar.GetToolBarCtrl().EnableButton(ID_CLOSEBUTTON, FALSE);
			 }

		}
		return 0;
	}
	
	return CDialog::WindowProc(message, wParam, lParam);
}

BOOL CPsmonitorDlg::DestroyWindow() 
{
	NOTIFYICONDATA IconData;
	IconData.cbSize = sizeof(IconData);
	IconData.hWnd = m_hWnd;
	IconData.uID = IDI_TRAY;
	sprintf(IconData.szTip,"PILab Server Monitor");
	Shell_NotifyIcon(NIM_DELETE, &IconData);

	KillTimer(1);
	
	return CDialog::DestroyWindow();
}

void CPsmonitorDlg::OnDevbutton() 
{
   	char    file[_MAX_PATH];
	sprintf(file, "%s%s", Dir,"devprop.exe");
	ShellExecute(NULL, NULL, file, NULL,NULL,SW_SHOWNORMAL);
	
}


void CPsmonitorDlg::OnStartbutton() 
{
	if(ServerDlg == NULL)
	{
   		char    file[_MAX_PATH];
		sprintf(file, "%s%s", Dir,"pilabserver.exe");
		ShellExecute(NULL, NULL, file, NULL,NULL,SW_SHOWNORMAL);
	}
}

void CPsmonitorDlg::OnClosebutton() 
{
	::SendMessage(ServerDlg, WM_USER+_ID_COMMAND_SHUTDOWN_, 0, 0);
	
}


void CPsmonitorDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	

	if(bShow == TRUE)
	{
		Show = true;
	}
	else
	{
		Show = false;
	}
}
