#if !defined(AFX_CLIENTSOCKET_H__21824C4F_72C8_11D4_9005_00C0DFE9E087__INCLUDED_)
#define AFX_CLIENTSOCKET_H__21824C4F_72C8_11D4_9005_00C0DFE9E087__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ClientSocket.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CClientSocket command target
#include "\cpp\tcpdata.h"

#include "\cpp\Fifo.h"
#include "tcpclientdefs.h"

class CClientSocket : public CSocket
{
// Attributes
public:

// Operations
public:
	CClientSocket();
	virtual ~CClientSocket();

	SocketCallback	SocketOnAccept;
	SocketCallback	SocketOnClose;
	SocketCallback	SocketOnConnect;
	SocketCallback	SocketOnReceive;
	SocketCallback	SocketOnSend;
	SocketErrorCallback	SocketOnError;

	TCPFUNCTION1	ProcessFunction;

	UINT		SocketId;

	CFifo		InBuffer;
	CFifo		OutBuffer;

// Overrides
public:
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CClientSocket)
	public:
	virtual void OnClose(int nErrorCode);
	virtual void OnConnect(int nErrorCode);
	virtual void OnReceive(int nErrorCode);
	virtual void OnSend(int nErrorCode);
	//}}AFX_VIRTUAL

	// Generated message map functions
	//{{AFX_MSG(CClientSocket)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

// Implementation
protected:
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CLIENTSOCKET_H__21824C4F_72C8_11D4_9005_00C0DFE9E087__INCLUDED_)
