// Sockets.cpp: implementation of the CSockets class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "tcpclient.h"
#include "Sockets.h"
#include "\cpp\tcpdata.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CClientSockets::CClientSockets()
	:_PtrList()
{

}

CClientSockets::~CClientSockets()
{
	Clear();
}

CClientSocket*	CClientSockets::Item(int index)
{
	return (CClientSocket*)(_PtrList::Item(index));
}

/*CClientSocket*	CClientSockets::Item(POSITION Pos)
{
	return (CClientSocket*)(List.GetAt(Pos));
}
*/
int	CClientSockets::FindIndex(CClientSocket* Socket)
{
	for(UINT i=0;i<GetCount();i++)
		if( Item(i)->m_hSocket == Socket->m_hSocket)
			return i;
	return -1;
}

int	CClientSockets::FindIndexId(UINT	SocketId)
{
	for(UINT i=0;i<GetCount();i++)
		if( Item(i)->SocketId == SocketId)
			return i;
	return -1;
}

CClientSocket*	CClientSockets::FindId(UINT SocketId)
{
	for(UINT i=0;i<GetCount();i++)
	{
		CClientSocket *Socket = Item(i);
		if( Socket->SocketId == SocketId)
			return Socket;
	}
	return NULL;
}

CClientSocket*	CClientSockets::New(void)
{
	CClientSocket *newSocket = new CClientSocket();
	Add(newSocket);
	return newSocket;
}

BOOL	CClientSockets::Delete(int index)
{
	CClientSocket *newSocket = Item(index);
	if(newSocket == NULL)
		return FALSE;
	delete newSocket;
	_PtrList::Delete(index);
	return TRUE;
}

BOOL	CClientSockets::DeleteId(UINT SocketId)
{
	int index = FindIndexId(SocketId);
	if(index == -1)
		return FALSE;
	
	return Delete(index);
}

BOOL	CClientSockets::Clear(void)
{
	while(GetCount() > 0)
	{
		Delete(0);
	}
	return TRUE;
}
