#include "\cpp\tcpdata.h"

#ifndef _tcp_client_defs_h_included_
#define _tcp_client_defs_h_included_

typedef void  (CALLBACK *SocketCallback)(LPVOID Sender);
typedef void  (CALLBACK *SocketErrorCallback)(LPVOID Sender, WORD Code, LPSTR Description);

#if !defined TCPFUNCTION1
typedef BOOL (*TCPFUNCTION1)(UINT SocketId, UINT Message);
#endif

#if !defined TCPErrorStruct
typedef struct tcpErrorStructTag{
	WORD	Code;
	LPSTR	Description;
	}TCPErrorStruct,*pTCPErrorStruct;
#endif

#define	_ID_NO_ERROR_					0x0000

#define	_ID_COMMAND_CREATE_SOCKET_		0x0001
#define	_ID_COMMAND_DESTROY_SOCKET_		0x0002

#define	_ID_TCP_MESSAGE_				0x0100
#define	_ID_TCP_MESSAGE_CONNECTED_		0x0101
#define	_ID_TCP_MESSAGE_DISCONNECTED_	0x0102
#define	_ID_TCP_ERROR_					0x0103

#define _ID_TCP_ERROR_WSAENETDOWN_		0x1001  
//The Windows Sockets implementation detected that the network subsystem failed.

#define _ID_TCP_ERROR_WSAECONNRESET_	0x1002  
//The connection was reset by the remote side.

#define _ID_TCP_ERROR_WSAECONNABORTED_	0x1003  
//The connection was aborted due to timeout or other failure.

#endif