#if !defined(AFX_SESSIONTHREAD_H__111278A1_4D38_492E_82AD_1BBB285ABF01__INCLUDED_)
#define AFX_SESSIONTHREAD_H__111278A1_4D38_492E_82AD_1BBB285ABF01__INCLUDED_

#include "userdlg.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SessionThread.h : header file
//


/////////////////////////////////////////////////////////////////////////////
// CSessionThread thread

class CSessionThread : public CWinThread
{
public:
	DECLARE_DYNCREATE(CSessionThread)
//protected:
	CSessionThread();           // protected constructor used by dynamic creation

// Attributes
public:
	CSessionThread(CWnd *Parent);
	SOCKET	hConnectedSocket;

	CWnd *Parent;
	bool	terminate;

	void	CloseAll();
// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSessionThread)
	public:
	virtual BOOL InitInstance();
	virtual int Run();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementation
//protected:
	virtual ~CSessionThread();

	// Generated message map functions
	//{{AFX_MSG(CSessionThread)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};



typedef struct tagSModuleInfo{
	CString Name;
	CString	moduleName;
	CSessionThread	*thread;
}SModuleInfo;

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SESSIONTHREAD_H__111278A1_4D38_492E_82AD_1BBB285ABF01__INCLUDED_)
