#ifndef _exports_h_included_
#define _exports_h_included_

#include "\cpp\tcpdata.h"

#if !defined TCPFUNCTION1
typedef BOOL (*TCPFUNCTION1)(UINT SocketId, UINT Message);
#endif


extern "C" __declspec(dllimport) UINT CreateSocket(UINT	ProcessFunction);
//	ProcessFunction must be the TCPFUNCTION1 type
//	return value - new socket Id

extern "C" __declspec(dllimport) BOOL DestroySocket(UINT SocketId);
extern "C" __declspec(dllimport) BOOL Connect(UINT SocketId, LPCTSTR Address, UINT Port);
extern "C" __declspec(dllimport) BOOL Send(UINT SocketId, BYTE *buffer, UINT count);

extern "C" __declspec(dllimport) UINT GetReceiveLen(UINT SocketId);
extern "C" __declspec(dllimport) BOOL ReceiveAlphaNumLine(UINT SocketId, LPSTR buffer, UINT MaxLen);
extern "C" __declspec(dllimport) BOOL Receive_Buffer(UINT SocketId, BYTE *buffer, UINT MaxLen);
extern "C" __declspec(dllimport) BOOL Receive_Struct(UINT SocketId, TCPDataStruct *Data);
#endif
