#if !defined(AFX_CIRCEXP02SDLG_H__1D847F41_1A25_4B29_9F0C_07F853725CD4__INCLUDED_)
#define AFX_CIRCEXP02SDLG_H__1D847F41_1A25_4B29_9F0C_07F853725CD4__INCLUDED_

#include "..\..\pilabrs485\comm485.h"
#include "\cpp\commands.h"
#include "\cpp\arrays.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CircExp02SDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CCircExp02SDlg dialog

class CCircExp02SDlg : public CDialog
{
// Construction
public:
	CCircExp02SDlg(CWnd* pParent = NULL);   // standard constructor


	BYTE			Switches[12];
	AOParameters	AOPar;
	AIParameters	AIPar;
	int			NChannels;
	int			*Channels;
	_PtrArray<SOURCE>	Sources;
	MEASUREPARAMS		Measure;

	HINSTANCE	NIDAQDLL;
	FUNCTION1	NIDAQFunction;

	BYTE			devAddress;
	int				timeouts;

	bool			Prepared;

	void			Clear();
	void			StartExperiment();
	void			SetSwitches(BYTE *values);

// Dialog Data
	//{{AFX_DATA(CCircExp02SDlg)
	enum { IDD = IDD_CIRCEXP02SDLG_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCircExp02SDlg)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CCircExp02SDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CIRCEXP02SDLG_H__1D847F41_1A25_4B29_9F0C_07F853725CD4__INCLUDED_)
