// MyListBox.cpp : implementation file
//

#include "stdafx.h"
#include "MyListBox.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyListBox

CMyListBox::CMyListBox()
{
	Header = NULL;
}

CMyListBox::~CMyListBox()
{
}


BEGIN_MESSAGE_MAP(CMyListBox, CListBox)
	//{{AFX_MSG_MAP(CMyListBox)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyListBox message handlers

void CMyListBox::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
char	string[6][100],*str1,*str3;
int	offset=0;
int	defOffset = 50;

	CString String;
	HBRUSH	Brush;

if(lpDrawItemStruct->itemAction == ODA_DRAWENTIRE || lpDrawItemStruct->itemAction == ODA_SELECT)
{
	if(lpDrawItemStruct->itemState & ODS_SELECTED)
	{
		Brush = CreateSolidBrush(0xff0000);
		SetTextColor(lpDrawItemStruct->hDC,0xffffff);
	}
	else
	{
		Brush = CreateSolidBrush(0xffffff);
		SetTextColor(lpDrawItemStruct->hDC,0x000000);
	}
	::FillRect(lpDrawItemStruct->hDC,&(lpDrawItemStruct->rcItem),Brush);

	int index = lpDrawItemStruct->itemData;
	int len = GetTextLen(index);
	str1 = new char[len+1];
	GetText(lpDrawItemStruct->itemData,str1);
	str1[len] = 0;
	if(str1 == NULL || CString(str1) == "")
		return;
    strtok(str1, "#");
    sprintf(string[0], "%s", str1);
    str3 = strtok(NULL, "#");
	int Headers;
	if(Header != NULL)
	{
		Headers = (int)Header->Tabs.GetCount();
	}
	else
		Headers = 1;

    for(int i=1;i<Headers;i++)
    {
            sprintf(string[i], "%s", str3);
            str3 = strtok(NULL, "#");
    }
	SetBkMode(lpDrawItemStruct->hDC, TRANSPARENT); 
    for(i=0;i<Headers;i++)
    {
		::TextOut( lpDrawItemStruct->hDC, lpDrawItemStruct->rcItem.left+offset, 
										lpDrawItemStruct->rcItem.top, string[i], strlen(string[i]));
		if(Header != NULL)
		{
            offset+= Header->Tabs[i]->Size;
		}
		else
			offset+=defOffset;
    }
	delete str1;
}
}

void CMyListBox::MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemStruct) 
{
	// TODO: Add your code to determine the size of specified item
	lpMeasureItemStruct->itemHeight = 16;
}
