#if !defined(_i8051_definitions_file_included_)
#define _i8051_definitions_file_included_

#define errNOERROR	0x00
#define errTIMEOUT	0xf0
#define errBADLENGTH	0xf1
#define errBADCRC		0xf2

#define cmCHARACTER	'@'
#define cmTEST			0xf0
#define cmDATA			0xf1
#define cmSTART		0xf2
#define cmEND			0xf3
#define cmOK			0xf4
#define cmERROR		0xf5
#define cmCSUMM		0xf6
#define cmNOTASK		0xf7
#define cmSET			0xf8

#define tm0BAUD5MS	100	
#define tm0BAUD2MS	40	
#define tm0PRESC		100	

#define TIMEOUT		20


#define	TXDBUF_SIZE	100
#define	RXDBUF_SIZE	255

#define ENABLESERIAL			REN=1;RI=0;
#define DISABLESERIAL 		REN=0;	

#define ENABLEGLOBALINT	 	EA=1;
#define DISABLEGLOBALINT 	EA=0;	

#define STARTTIMER0			TR0=1;
#define STOPTIMER0			TR0=0;

#define STARTTIMER1			TR1=1;
#define STOPTIMER1			TR1=0;

#define STARTTIMER2			TR2=1;
#define STOPTIMER2			TR2=0;


#define ENABLET0INT			ET0=1;
#define DISABLET0INT			ET0=0;

#define ENABLET1INT			ET1=1;
#define DISABLET1INT			ET1=0;

#define ENABLET2INT			ET2=1;
#define DISABLET2INT			ET2=0;

#define ENABLEWDT				WMCON=WMCON|0x01;
#define DISABLEWDT			WMCON=WMCON&0xFE;
#define RESETWDT				WMCON=WMCON|0x02;

#define MXOFF					0x88
 
#define WARMSTART				0xFF 
#define COLDSTART				0x00 


#endif