#include "stdafx.h"

#include "labdatatrans_vc.h"

//-----------------------------------------------------------------------------------------
VARIANT _LabDataToVariant(_LabData *Data)
{
VARIANT	var;
SAFEARRAY *psa;
SAFEARRAYBOUND sa[2];
long rgIndices[2];
double d;
UINT	i;

	int Dimms = Data->GetDimCount();

		sa[1].cElements = Data->Dim(0)->GetSize();
		sa[1].lLbound = 0;
		sa[0].cElements = Dimms;
		sa[0].lLbound = 0;
		psa = SafeArrayCreate(VT_R8, Dimms, sa);
		ASSERT(psa);

	for(int dim=0;dim<Dimms;dim++)
	{
		for(i=0;i<sa[1].cElements;i++)
        {
			rgIndices[1] = i;
			rgIndices[0] = dim;
			d = Data->Item(dim,i);
			SafeArrayPutElement(psa, rgIndices, &d);
        }
	}
	var.vt = VT_ARRAY | VT_R8; // array of doubles
	var.parray = psa;
    return var;
}
//-----------------------------------------------------------------------------------------
