#include <vcl.h>
#include <stdio.h>
#include <string.h>
//************************************************************************
UINT SplitString(AnsiString Source, TStringList *words)
{
    Source.TrimLeft();
    Source.TrimRight();

	UINT space,count=0;
	if(Source.Length() > 0)
	{
		space = Source.Pos(" ");
		while(space != 0)
		{
			AnsiString word = Source.SubString(1,space);
			Source.Delete(1, space);
		    Source.TrimLeft();
			words->Add(word);
			count++;
			space = Source.Pos(" ");
		}
		words->Append(Source);
		count++;
	}
	return count;
}

UINT	BufToString(BYTE *buffer, UINT len, char* &string)
{
	char word[5];
	UINT shift=0;
	string = new char[len*5+1];
	for(UINT i=0;i<len;i++)
	{
		_ltoa((long)buffer[i], word, 16);
		UINT sz = (UINT)strlen(word);
		if(sz == 1)
		{
			word[2] = 0;
			word[1] = word[0];
			word[0] = '0';
			sz = 2;
		}
		memcpy(string+shift, word, sz);
		shift+=sz;
	}
	string[shift] = 0;
	return (UINT)strlen(string);
}

UINT	StringToBuf(char* string, BYTE* &buffer)
{
	UINT Count = strlen(string)/2;
	if(Count > 0)
	{
		buffer = new BYTE[Count];
		char w[3];
		w[2] = 0;
		for(UINT i=0;i<Count;i++)
		{
			UINT index = i*2;
			w[0] = string[index];
			w[1] = string[index+1];
			int value;
			sscanf(w,"%x",&value);
			buffer[i] = (BYTE)(value);
		}
	}

	return Count;
}