// DiodExp01SDlg.cpp : implementation file
//

#include "stdafx.h"
#include "diod01s.h"
#include "DiodExp01SDlg.h"

//#include "\cpp\commands.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern	char		moduleName[];
extern	HWND			MainWindow;

extern	CDiodExp01SDlg	*ExpWnd;
extern	char			ProFile[_MAX_PATH];

/////////////////////////////////////////////////////////////////////////////
// CDiodExp01SDlg dialog


CDiodExp01SDlg::CDiodExp01SDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDiodExp01SDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDiodExp01SDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CDiodExp01SDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDiodExp01SDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDiodExp01SDlg, CDialog)
	//{{AFX_MSG_MAP(CDiodExp01SDlg)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CDiodExp01SDlg::Clear()
{
}


/////////////////////////////////////////////////////////////////////////////
// CDiodExp01SDlg message handlers

BOOL CDiodExp01SDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	devAddress = GetPrivateProfileInt(moduleName, "RSAddress", 0xed, ProFile);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDiodExp01SDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	Clear();
	
}

LRESULT CDiodExp01SDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	switch(message)
	{
	case WM_TIMER:
		{
			if(wParam == 3)//**** read data
			{
				KillTimer(3);
char str[512];
sprintf(str, "ReadingData");
::SendMessage(MainWindow, _ID_DATA_STATUS_STRING_, (WPARAM)str, (LPARAM)strlen(str));
				CRS485Message newData;
				newData.SetAddress(devAddress);
				newData.SetID(cmDATA);
				BYTE	buffer[1];
				buffer[0] = 0xFF;
				newData.SetData(1, buffer);
				newData.CalcChSum();
				::SendMessage(MainWindow, _ID_RS485_COMMAND_+_ID_COMMAND_SEND_DATA_, (WPARAM)&newData, 0);
				timeouts = 0;
			}
		}
		break;
	case _ID_COMMAND_EXPERIMENT_START_:
		{
char str[512];
sprintf(str, "ExperimentStart");
::SendMessage(MainWindow, _ID_DATA_STATUS_STRING_, (WPARAM)str, (LPARAM)strlen(str));
			if(wParam != NULL)
			{
				BYTE *buffer = ((BYTE*)wParam);
				UINT Count;
				memcpy(&Count, buffer, sizeof(UINT));
				Parameter = *(buffer+sizeof(UINT));
				::SendMessage(MainWindow, _ID_RS485_COMMAND_+_ID_COMMAND_OPEN_DEVICE_, (WPARAM)devAddress, 0);
				CRS485Message newData;
				newData.SetAddress(devAddress);
				newData.SetID(cmSTART);
				newData.SetData(1, &Parameter);
/*{
	FILE *file = fopen("diods.txt", "a+");
	fprintf(file, "Parameter == %d\n", Parameter);
	fclose(file);
}
*/
				newData.CalcChSum();
				::SendMessage(MainWindow, _ID_RS485_COMMAND_+_ID_COMMAND_SEND_DATA_, (WPARAM)&newData, 0);
				timeouts = 0;
			}
		}
		return 0;
	case _ID_SYSTEM_UNINITIALIZE_:
		{
			::SendMessage(MainWindow, _ID_RS485_COMMAND_+_ID_COMMAND_CLOSE_DEVICE_, (WPARAM)devAddress, 0);
			Clear();
		}
		return 0;
	case _ID_RS485_MESSAGE_:
		switch(wParam)
		{
		case _ID_RS485_MESSAGE_:
			{
				CRS485Message *mes = (CRS485Message*)lParam;
				int	ID = (int)mes->GetID();
				switch(ID)
				{
				case cmOK:
					StartExperiment();
					break;
				case cmDATA:
						::SendMessage(MainWindow, _ID_DATA_GRAPH_, (WPARAM)(mes->GetData()), (LPARAM)(mes->GetLen()));
						::PostMessage(MainWindow, _ID_COMMAND_EXPERIMENT_END_, 0, 0);
					break;
				default:
					timeouts++;
					if(timeouts > 3)
					{
						::SendMessage(MainWindow, _ID_COMMAND_SEND_ERROR_, _ID_RS485_COMMAND_+ID, 0);
					}
					else
					{
						::SendMessage(MainWindow, _ID_RS485_COMMAND_+_ID_COMMAND_SEND_DATA_RETRIEVE_, (WPARAM)devAddress, 0);
					}
					break;
				}
			}
			break;
		case errTIMEOUT:
			{
			timeouts++;
			if(timeouts > 3)
			{
				::SendMessage(MainWindow, _ID_COMMAND_SEND_ERROR_, _ID_RS485_COMMAND_+errTIMEOUT, 0);
			}
			else
			{
				::SendMessage(MainWindow, _ID_RS485_COMMAND_+_ID_COMMAND_SEND_DATA_RETRIEVE_, (WPARAM)devAddress, 0);
			}
			}
			break;
		}
		return 0;
	}
	
	return CDialog::WindowProc(message, wParam, lParam);
}

void CDiodExp01SDlg::StartExperiment()
{
	SetTimer(3, 1000, NULL);
}
