// MCExp01SDlg.cpp : implementation file
//

#include "stdafx.h"
#include "mc01s.h"
#include "MCExp01SDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern	char		moduleName[];
extern	HWND			MainWindow;

extern	CMCExp01SDlg	*ExpWnd;
extern	char			ProFile[_MAX_PATH];

/////////////////////////////////////////////////////////////////////////////
// CMCExp01SDlg dialog


CMCExp01SDlg::CMCExp01SDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMCExp01SDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMCExp01SDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CMCExp01SDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMCExp01SDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMCExp01SDlg, CDialog)
	//{{AFX_MSG_MAP(CMCExp01SDlg)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMCExp01SDlg message handlers

LRESULT CMCExp01SDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	switch(message)
	{
	case WM_TIMER:
		{
			if(wParam == 3)//**** read data
			{
				KillTimer(3);
char str[512];
sprintf(str, "ReadingData");
::SendMessage(MainWindow, _ID_DATA_STATUS_STRING_, (WPARAM)str, (LPARAM)strlen(str));
								CRS485Message newData;
								newData.SetAddress(devAddress);
								newData.SetID(cmDATA);
								Status = cmDATA;
								newData.SetData(0, NULL);
								newData.CalcChSum();
								::SendMessage(MainWindow, _ID_RS485_COMMAND_+_ID_COMMAND_SEND_DATA_, (WPARAM)&newData, 0);
								timeouts = 0;
			}
		}
		break;
	case _ID_COMMAND_EXPERIMENT_START_:
		{
char str[512];
sprintf(str, "ExperimentStart");
::SendMessage(MainWindow, _ID_DATA_STATUS_STRING_, (WPARAM)str, (LPARAM)strlen(str));
			if(wParam != NULL)
			{
				BYTE *buffer = (BYTE*)wParam;
				UINT len;
				memcpy(&len, buffer, sizeof(UINT));
				::SendMessage(MainWindow, _ID_RS485_COMMAND_+_ID_COMMAND_OPEN_DEVICE_, (WPARAM)devAddress, 0);
				CRS485Message newData;
				newData.SetAddress(devAddress);
				newData.SetID(cmSET);
				Status = cmSET;
				newData.SetData(len, (buffer+sizeof(UINT)));
				newData.CalcChSum();
				::SendMessage(MainWindow, _ID_RS485_COMMAND_+_ID_COMMAND_SEND_DATA_, (WPARAM)&newData, 0);
				timeouts = 0;
			}
		}
		return 0;
	case _ID_SYSTEM_UNINITIALIZE_:
		{
			::SendMessage(MainWindow, _ID_RS485_COMMAND_+_ID_COMMAND_CLOSE_DEVICE_, (WPARAM)devAddress, 0);
			Clear();
		}
		return 0;
	case _ID_RS485_MESSAGE_:
		switch(wParam)
		{
		case _ID_RS485_MESSAGE_:
			{
				CRS485Message *mes = (CRS485Message*)lParam;
				int	ID = (int)mes->GetID();
				switch(ID)
				{
				case cmOK:
					{
						switch(Status)
						{
						case cmSET:
							{
char str[512];
sprintf(str, "ExpStart");
::SendMessage(MainWindow, _ID_DATA_STATUS_STRING_, (WPARAM)str, (LPARAM)strlen(str));
								CRS485Message newData;
								newData.SetAddress(devAddress);
								newData.SetID(cmSTART);
								Status = cmSTART;
								newData.SetData(0, NULL);
								newData.CalcChSum();
								::SendMessage(MainWindow, _ID_RS485_COMMAND_+_ID_COMMAND_SEND_DATA_, (WPARAM)&newData, 0);
								timeouts = 0;
							}
							break;
						case cmSTART:
							break;
						}
					if(!Started)
						StartExperiment();
					}
					break;
				case cmDATA:
						::SendMessage(MainWindow, _ID_DATA_GRAPH_, (WPARAM)(mes->GetData()), (LPARAM)(mes->GetLen()));
						::PostMessage(MainWindow, _ID_COMMAND_EXPERIMENT_END_, 0, 0);
					break;
				default:
					timeouts++;
					if(timeouts > 3)
					{
						::SendMessage(MainWindow, _ID_COMMAND_SEND_ERROR_, _ID_RS485_COMMAND_+ID, 0);
					}
					else
					{
						::SendMessage(MainWindow, _ID_RS485_COMMAND_+_ID_COMMAND_SEND_DATA_RETRIEVE_, (WPARAM)devAddress, 0);
					}
					break;
				}
			}
			break;
		case errTIMEOUT:
			{
			timeouts++;
			if(timeouts > 3)
			{
				::SendMessage(MainWindow, _ID_COMMAND_SEND_ERROR_, _ID_RS485_COMMAND_+errTIMEOUT, 0);
			}
			else
			{
				::SendMessage(MainWindow, _ID_RS485_COMMAND_+_ID_COMMAND_SEND_DATA_RETRIEVE_, (WPARAM)devAddress, 0);
			}
			}
			break;
		}
		return 0;
	}
	
	return CDialog::WindowProc(message, wParam, lParam);
}

void CMCExp01SDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	Clear();
	
}

void CMCExp01SDlg::Clear()
{
	if(Parameters != NULL)
	{
		delete[] Parameters;
		Parameters = NULL;
	}
}


BOOL CMCExp01SDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	Parameters = NULL;
	ParLen = 0;
	devAddress = GetPrivateProfileInt(moduleName, "RSAddress", 231, ProFile);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CMCExp01SDlg::StartExperiment()
{
	SetTimer(3, 1000, NULL);
}
