#if !defined(AFX_OPEREXPCDLG_H__19AB67F3_E41E_4BD9_936C_3F1925AFB638__INCLUDED_)
#define AFX_OPEREXPCDLG_H__19AB67F3_E41E_4BD9_936C_3F1925AFB638__INCLUDED_

#include "imports.h"
#include "\cpp\arrays.h"
#include "\cpp\tcpdata.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// OperExpCDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// COperExpCDlg dialog

class COperExpCDlg : public CDialog
{
// Construction
public:
	COperExpCDlg(CWnd* pParent = NULL);   // standard constructor

	bool	Cancelled;

	UINT	SocketId;
	bool	connected;
	_PtrQueue<TCPDataStruct>	Queue;
	bool	QueueBusy;
	bool	complete;


	BOOL Start();
	void	Stop();
	void	QueueCanSend();
	void	Queue_Send();

	void	SendStruct(TCPDataStruct* Data);
	void	SendStruct_Queue(TCPDataStruct* Data);
	
	void	SendMessage_Queue(UINT FuncId, BYTE *buffer, UINT Len);
	void	SendMessage_(UINT FuncId, BYTE *buffer, UINT Len);
	
//	void	SendBuffer_Queue(BYTE *buffer, UINT Len);
	void	SendBuffer(BYTE *buffer, UINT Len);
// Dialog Data
	//{{AFX_DATA(COperExpCDlg)
	enum { IDD = IDD_OPEREXPCDLG_DIALOG };
	CProgressCtrl	m_Progress;
	CEdit	m_Status;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COperExpCDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(COperExpCDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnDestroy();
	virtual void OnCancel();
	afx_msg void OnDblclkList1();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_OPEREXPCDLG_H__19AB67F3_E41E_4BD9_936C_3F1925AFB638__INCLUDED_)
